const int trigPin = 9;
const int echoPin = 10;
const int Buzzer = 12;
const int ledPin= 13;
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27,20,4);

int duration, distance; 
int distanceCm, distanceInch;

void print_distance(int distanceCm, int distanceInch){
    lcd.setCursor(0,1); 
    lcd.print("Distance: "); 
    lcd.print(distanceCm); 
    lcd.print(" cm   ");
    delay(10);
    lcd.setCursor(0,2);
    lcd.print("Distance: ");
    lcd.print(distanceInch);
    lcd.print(" inch  ");
    delay(10);
}

void print_undetected(){
    lcd.setCursor(0,1); 
    lcd.print("No object detected  "); 
    delay(10);
    lcd.setCursor(0,2);
    lcd.print("No object detected  ");
    delay(10);
}

void setup() {
    lcd.init();
    lcd.backlight();
    pinMode(Buzzer, OUTPUT);
    pinMode(ledPin, OUTPUT);
    pinMode(trigPin, OUTPUT); 
    pinMode(echoPin, INPUT);
}

void loop() {

    digitalWrite(trigPin, LOW);
    delayMicroseconds(2);
    digitalWrite(trigPin, HIGH);
    delayMicroseconds(10);
    digitalWrite(trigPin, LOW);
    
    duration = pulseIn(echoPin, HIGH);
    distanceCm = (duration*0.0343)/2;
    distanceInch = (duration*0.0133)/2;
    
    
    if (distanceCm >= 500 || distanceCm <= 0) 
        {
        digitalWrite(Buzzer,LOW);
        noTone(Buzzer);
        digitalWrite(ledPin,LOW);

        print_undetected();    
    }
    else if(distanceCm >= 100 && distanceCm < 500){
        tone(Buzzer,100);             
        digitalWrite(ledPin,HIGH);
        delay(200);
        digitalWrite(ledPin,LOW);
        delay(200);
    
        print_distance(distanceCm, distanceInch);
    }
    else if(distanceCm >= 50 && distanceCm < 100){
        tone(Buzzer,275);             
        digitalWrite(ledPin,HIGH);
        delay(150);
        digitalWrite(ledPin,LOW);
        delay(150);
        
        print_distance(distanceCm, distanceInch);
    }
    else if(distanceCm >= 20 && distanceCm < 50){
        tone(Buzzer,400);             
        digitalWrite(ledPin,HIGH);
        delay(80);
        digitalWrite(ledPin,LOW);
        delay(80);

        print_distance(distanceCm, distanceInch);
    }
    else if(distanceCm < 20){
        tone(Buzzer,600);             
        digitalWrite(ledPin,HIGH);
        delay(25);
        digitalWrite(ledPin,LOW);
        delay(25);

        print_distance(distanceCm, distanceInch);
    }
}
